<?php
# this script runs when student submits code
include_once("common.php");
# phpinfo();
?>

<html>
<head>
	<title>Submit program</title>
</head>

<body>
	<h1>Submitting your program</h1>
	
	<p>
		This submission has been logged.  You submitted from <?= $_SERVER["REMOTE_HOST"] ?> at <?= $_SERVER["REMOTE_ADDR"] ?>.
	</p>

<?php
check_params("name", "email", "section", "compilecommand", "runcommand", "filename");
check_param("program", $_FILES);
# print_r($_FILES);

# check section
$section = $_POST["section"];
$student = $_POST["name"];
$email = $_POST["email"];
$uwnetid = preg_replace("/\@.*/", "", $email);
$filename = $_POST["filename"];
$time = date("D Y/M/d h:ia", time());

print("<h3>Student info:</h3>");
print_p("name: $student<br>email: $email<br>section: $section<br>$filename: $filename");
print("<hr>");

$section_folder = "sections/$section";
if (!is_dir($section_folder)) {
	print_p("ERROR: section $section not found.  Sections found:\n" . 
			implode(", ", scandir("sections/")));
	die();
}

# check student
if (!$student) {
	print_p("ERROR: student parameter cannot be empty.  Students found:\n" . 
			implode(", ", scandir($section_folder)));
	die();
}

# possibly overwrite old data, or create new student
$student_folder = "$section_folder/$uwnetid";
$program_file = "$student_folder/$filename";
if (is_dir($student_folder)) {
	# overwriting a previous turnin
	$old_program = file_get_contents($program_file);
	print_p("NOTE: Replacing the following previous version of your program:");
	print_pre($old_program);
	print("<hr>");
} else {
	# create new student
	mkdir($student_folder, 0777, TRUE);
}

# save submitted program
move_uploaded_file($_FILES["program"]["tmp_name"], $program_file);
chmod($program_file, 0777);
$program = file_get_contents($program_file);

# compile and run
$compiler = $_POST["compilecommand"];

# securtiy check!
if (!preg_match("/^javac/", $compiler)) {
	die("Invalid compiler command (must begin with javac): $compiler");
}

$output = "";
$return_result = NULL;
$command = "cd $student_folder && $compiler $filename";
print_p("Compiling program: <code>$command</code>");
exec($command, $output, $return_result);
if ($output) {
	die("Compile failed (returned $return_result): $output");
}

$runner = $_POST["runcommand"];

# securtiy check!
if (!preg_match("/^java/", $compiler)) {
	die("Invalid compiler command (must begin with java): $runner");
}

# securtiy check! don't allow dot dot
$program_class = preg_replace("/\\.\\.*/", "", $filename);

$command = "cd $student_folder && $runner $program_class";
print_p("Running program: <code>$command</code>");
exec($command, $output, $return_result);

print("<h3>Program compiled and run successfully at $time.  Your output:</h3>");
print_pre(implode("\n", $output));

# email the student to let them know that the turnin succeeded (doesn't work)
# ini_set("SMTP", "stepp.mail.cs.washington.edu");
# ini_set("sendmail_from", "stepp@cs.washington.edu");
# mail($email, "CSE 144 turnin", "You successfully turned in the following code at $time:\n\n$program");

print("<hr>");
print_p("An email was sent to $email containing this information.");
?>

</body>
</html>
